/*
**
** PHiPAC Matrix-Matrix Code for the operation:
**    C = A*transpose(B) + C
**
** Automatically Generated by mm_cgen ($Revision: 1.27 $) using the command:
**    ./mm_cgen -prec double -opA N -opB T -alpha 1 -sp 1 -holdstripe B -l0 1 17 9 -no_fringes -file ./src/mm_double_NT_1_nofringe.c -routine_name mm_double_NT_1_nofringe 
**
** Run './mm_cgen -help' for help.
**
** WARNING: This routine was generated without code for
** fringes in the following dimension(s): M K N 
** That means that the routine will only work for matrices with the
** appropriate size(s). See the 'Routine Usage' below for details.
**
** Generated on: Wednesday July 10 2013, 08:33:28 PDT
** Created by: Jeff Bilmes <bilmes@cs.berkeley.edu>
**             http://www.icsi.berkeley.edu/~bilmes/phipac
**
**
** Routine Usage: General (M,K,N) = (m*1:m>=0, k*17:k>=0, n*9:n>=0) matrix multiply
**    mm_double_NT_1_nofringe(const int M, const int K, const int N, const double *const A, const double *const B, double *const C, const int Astride, const int Bstride, const int Cstride)
** where
**  A is an MxK matrix
**  transpose(B) is an KxN matrix
**  C is an MxN matrix
**  Astride is the number of entries between the start of each row of A
**  Bstride is the number of entries between the start of each row of B
**  Cstride is the number of entries between the start of each row of C
**
**
** "Copyright (c) 1995 The Regents of the University of California.  All
** rights reserved."  Permission to use, copy, modify, and distribute
** this software and its documentation for any purpose, without fee, and
** without written agreement is hereby granted, provided that the above
** copyright notice and the following two paragraphs appear in all copies
** of this software.
**
** IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
** DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
** OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
** CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
** THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
** INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
** AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
** ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
** PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
**
*/

/*
 * General (M,K,N) = (m*1:m>=0, k*17:k>=0, n*9:n>=0) matrix multiply
 */
void
mm_double_NT_1_nofringe(const int M, const int K, const int N, const double *const A, const double *const B, double *const C, const int Astride, const int Bstride, const int Cstride)
{
   const double *a,*b;
   double *c;
   const double *ap_0;
   const double *bp_0,*bp_1,*bp_2,*bp_3,*bp_4,*bp_5,*bp_6,*bp_7,*bp_8;
   double *cp;
   const int A_sbs_stride = Astride*1;
   const int B_sbs_stride = Bstride*9;
   const int C_sbs_stride = Cstride*1;
   const int k_marg_el = K % 17;
   const int k_norm = K - k_marg_el;
   const int m_marg_el = M & 0;
   const int m_norm = M - m_marg_el;
   const int n_marg_el = N % 9;
   const int n_norm = N - n_marg_el;
   double *const c_endp = C+m_norm*Cstride;
   register double c0_0,c0_1,c0_2,c0_3,c0_4,c0_5,c0_6,c0_7,c0_8;
   for (c=C,a=A; c!= c_endp; c+=C_sbs_stride,a+=A_sbs_stride) {
      const double* const ap_endp = a + k_norm;
      double* const cp_endp = c + n_norm;
      for (b=B,cp=c; cp!=cp_endp; b+=B_sbs_stride,cp+=9) {
         register double _b0,_b1,_b2,_b3,_b4,_b5,_b6,_b7,_b8;
         register double _a0;
         double *_cp;
         ap_0 = a;
         bp_0 = b;
         bp_1 = bp_0 + Bstride;
         bp_2 = bp_1 + Bstride;
         bp_3 = bp_2 + Bstride;
         bp_4 = bp_3 + Bstride;
         bp_5 = bp_4 + Bstride;
         bp_6 = bp_5 + Bstride;
         bp_7 = bp_6 + Bstride;
         bp_8 = bp_7 + Bstride;
         _cp=cp;c0_0=_cp[0];c0_1=_cp[1];c0_2=_cp[2];c0_3=_cp[3];c0_4=_cp[4];c0_5=_cp[5];c0_6=_cp[6];c0_7=_cp[7];c0_8=_cp[8];
         for (;ap_0!=ap_endp; ap_0+=17,bp_0+=17,bp_1+=17,bp_2+=17,bp_3+=17,bp_4+=17,bp_5+=17,bp_6+=17,bp_7+=17,bp_8+=17) {
            /* Fixed M,K,N = 1,17,9 fully-unrolled matrix matrix multiply. */
            
            _b0 = bp_0[0]; _b1 = bp_1[0]; _b2 = bp_2[0]; _b3 = bp_3[0]; _b4 = bp_4[0]; _b5 = bp_5[0]; _b6 = bp_6[0]; _b7 = bp_7[0]; _b8 = bp_8[0]; 
            _a0 = ap_0[0];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[1]; _b1 = bp_1[1]; _b2 = bp_2[1]; _b3 = bp_3[1]; _b4 = bp_4[1]; _b5 = bp_5[1]; _b6 = bp_6[1]; _b7 = bp_7[1]; _b8 = bp_8[1]; 
            _a0 = ap_0[1];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[2]; _b1 = bp_1[2]; _b2 = bp_2[2]; _b3 = bp_3[2]; _b4 = bp_4[2]; _b5 = bp_5[2]; _b6 = bp_6[2]; _b7 = bp_7[2]; _b8 = bp_8[2]; 
            _a0 = ap_0[2];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[3]; _b1 = bp_1[3]; _b2 = bp_2[3]; _b3 = bp_3[3]; _b4 = bp_4[3]; _b5 = bp_5[3]; _b6 = bp_6[3]; _b7 = bp_7[3]; _b8 = bp_8[3]; 
            _a0 = ap_0[3];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[4]; _b1 = bp_1[4]; _b2 = bp_2[4]; _b3 = bp_3[4]; _b4 = bp_4[4]; _b5 = bp_5[4]; _b6 = bp_6[4]; _b7 = bp_7[4]; _b8 = bp_8[4]; 
            _a0 = ap_0[4];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[5]; _b1 = bp_1[5]; _b2 = bp_2[5]; _b3 = bp_3[5]; _b4 = bp_4[5]; _b5 = bp_5[5]; _b6 = bp_6[5]; _b7 = bp_7[5]; _b8 = bp_8[5]; 
            _a0 = ap_0[5];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[6]; _b1 = bp_1[6]; _b2 = bp_2[6]; _b3 = bp_3[6]; _b4 = bp_4[6]; _b5 = bp_5[6]; _b6 = bp_6[6]; _b7 = bp_7[6]; _b8 = bp_8[6]; 
            _a0 = ap_0[6];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[7]; _b1 = bp_1[7]; _b2 = bp_2[7]; _b3 = bp_3[7]; _b4 = bp_4[7]; _b5 = bp_5[7]; _b6 = bp_6[7]; _b7 = bp_7[7]; _b8 = bp_8[7]; 
            _a0 = ap_0[7];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[8]; _b1 = bp_1[8]; _b2 = bp_2[8]; _b3 = bp_3[8]; _b4 = bp_4[8]; _b5 = bp_5[8]; _b6 = bp_6[8]; _b7 = bp_7[8]; _b8 = bp_8[8]; 
            _a0 = ap_0[8];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[9]; _b1 = bp_1[9]; _b2 = bp_2[9]; _b3 = bp_3[9]; _b4 = bp_4[9]; _b5 = bp_5[9]; _b6 = bp_6[9]; _b7 = bp_7[9]; _b8 = bp_8[9]; 
            _a0 = ap_0[9];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[10]; _b1 = bp_1[10]; _b2 = bp_2[10]; _b3 = bp_3[10]; _b4 = bp_4[10]; _b5 = bp_5[10]; _b6 = bp_6[10]; _b7 = bp_7[10]; _b8 = bp_8[10]; 
            _a0 = ap_0[10];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[11]; _b1 = bp_1[11]; _b2 = bp_2[11]; _b3 = bp_3[11]; _b4 = bp_4[11]; _b5 = bp_5[11]; _b6 = bp_6[11]; _b7 = bp_7[11]; _b8 = bp_8[11]; 
            _a0 = ap_0[11];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[12]; _b1 = bp_1[12]; _b2 = bp_2[12]; _b3 = bp_3[12]; _b4 = bp_4[12]; _b5 = bp_5[12]; _b6 = bp_6[12]; _b7 = bp_7[12]; _b8 = bp_8[12]; 
            _a0 = ap_0[12];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[13]; _b1 = bp_1[13]; _b2 = bp_2[13]; _b3 = bp_3[13]; _b4 = bp_4[13]; _b5 = bp_5[13]; _b6 = bp_6[13]; _b7 = bp_7[13]; _b8 = bp_8[13]; 
            _a0 = ap_0[13];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[14]; _b1 = bp_1[14]; _b2 = bp_2[14]; _b3 = bp_3[14]; _b4 = bp_4[14]; _b5 = bp_5[14]; _b6 = bp_6[14]; _b7 = bp_7[14]; _b8 = bp_8[14]; 
            _a0 = ap_0[14];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[15]; _b1 = bp_1[15]; _b2 = bp_2[15]; _b3 = bp_3[15]; _b4 = bp_4[15]; _b5 = bp_5[15]; _b6 = bp_6[15]; _b7 = bp_7[15]; _b8 = bp_8[15]; 
            _a0 = ap_0[15];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 
            
            _b0 = bp_0[16]; _b1 = bp_1[16]; _b2 = bp_2[16]; _b3 = bp_3[16]; _b4 = bp_4[16]; _b5 = bp_5[16]; _b6 = bp_6[16]; _b7 = bp_7[16]; _b8 = bp_8[16]; 
            _a0 = ap_0[16];
            c0_0 += _a0*_b0; c0_1 += _a0*_b1; c0_2 += _a0*_b2; c0_3 += _a0*_b3; c0_4 += _a0*_b4; c0_5 += _a0*_b5; c0_6 += _a0*_b6; c0_7 += _a0*_b7; c0_8 += _a0*_b8; 

         }
         _cp=cp;_cp[0]=c0_0;_cp[1]=c0_1;_cp[2]=c0_2;_cp[3]=c0_3;_cp[4]=c0_4;_cp[5]=c0_5;_cp[6]=c0_6;_cp[7]=c0_7;_cp[8]=c0_8;
      }
   }
}
